## coot 1.1.08+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)
cmake_policy(SET CMP0048 NEW)
project(coot)
find_package(PkgConfig)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

set(CMAKE_CXX_STANDARD 17)

if (APPLE)
else()
   find_package(CCP4 REQUIRED mmdb2 ssm clipper-core clipper-mmdb clipper-ccp4 clipper-contrib clipper-minimol clipper-cif)
endif(APPLE)

find_package(BLAS)
find_package(GSL REQUIRED)
find_package(PNG REQUIRED)
find_package(GEMMI REQUIRED)
find_package(Threads REQUIRED)
find_package(Python REQUIRED)

find_package(Boost COMPONENTS iostreams system python regex thread serialization REQUIRED)
find_package(glm REQUIRED)


# Charles wants 3.9 here, but if I change to 3.9 then it will not build for me
# Hmm...
# What do I need to do here so that Charles can specify on the command line what the version of Python should be?
find_package(Python 3.10
  REQUIRED COMPONENTS Interpreter Development.Module
  OPTIONAL_COMPONENTS Development.SABIModule)

find_package(nanobind CONFIG REQUIRED)

# only via homebrew on macOS (not tried to compile them myself) - see below also though.
if (APPLE)
else()
   find_library(libelf elf)
   find_library(libdwarf dw)
endif(APPLE)

# From Charles
if (WIN32)
   string(REPLACE "\\" "/" Python_SITEARCH "${Python_SITEARCH}")
   string(REPLACE "\\" "/" Python_SITELIB  "${Python_SITELIB}")
endif(WIN32)


set(coot_src ${CMAKE_CURRENT_SOURCE_DIR})

add_definitions(-DANALYSE_REFINEMENT_TIMING -DVERSION="1.x-pre" -DPACKAGE_VERSION="1"
  -DHAVE_CXX_THREAD -DHAVE_SSMLIB -DHAVE_BOOST -DUSE_LIBPNG=1 -DCLIPPER_HAS_TOP8000 -DUSE_GEMMI -DHAVE_BOOST_THREAD -DHAVE_GSL
  -DPKGDATADIR="${CMAKE_INSTALL_PREFIX}/share/coot" -DXDATADIR="${CMAKE_INSTALL_PREFIX}/share")

if (ENHANCED_LIGAND_TOOLS)
   add_definitions(-DMAKE_ENHANCED_LIGAND_TOOLS)
   message("-- Found ENHANCED_LIGAND_TOOLS setting - now requiring the RDKit")
   find_package(Cairo REQUIRED)
   find_package(RDKit CONFIG COMPONENTS RDGeneral REQUIRED)
   set(RDKit_libs_for_libcootapi RDKit::rdkit_base RDKit::Descriptors RDKit::ForceFieldHelpers RDKit::ForceField RDKit::Optimizer RDKit::MolDraw2D  RDKit::MolChemicalFeatures)
else()
    message("-- Note: MAKE_ENHANCED_LIGAND_TOOLS was not enabled")
endif()

# we can be on Apple, and also have access to homebrew dwarf and elf - but this typically not the case
# should this actually be ENABLE_BACKWARD? (util/backward.cpp is not conditionally compiled)
if (ENABLE_DWARF_ELF)
   find_library(libelf elf)
   find_library(libdwarf dw)
   add_definitions(-DBACKWARD_HAS_DW)
   message("-- Enabled dwarf and elf")
endif()

#  pyrogen, auxil, goograph, src ignored.


add_library(cootapi SHARED
            ${coot_src}/lidia-core/svg-molecule.cc
            ${coot_src}/lidia-core/cod-types.cc
            ${coot_src}/lidia-core/cod-atom-types.cc
            ${coot_src}/lidia-core/chemical-feature-clusters.cc
            ${coot_src}/lidia-core/bond-record-container-t.cc
            ${coot_src}/lidia-core/atom-types.cc
            ${coot_src}/lidia-core/cod-atom-type-t.cc
            ${coot_src}/lidia-core/rdkit-interface.cc
            ${coot_src}/lidia-core/bond-table-record-t.cc
            ${coot_src}/pli/pi-stacking.cc
            ${coot_src}/src/coot-hydrogens.cc
            ${coot_src}/src/cfc.cc
            ${coot_src}/MoleculesToTriangles/CXXSurface/CXXBall.cpp
            ${coot_src}/MoleculesToTriangles/CXXSurface/CXXChargeTable.cpp
            ${coot_src}/MoleculesToTriangles/CXXSurface/CXXCircle.cpp
            ${coot_src}/MoleculesToTriangles/CXXSurface/CXXCircleNode.cpp
            ${coot_src}/MoleculesToTriangles/CXXSurface/CXXCoord.cpp
            ${coot_src}/MoleculesToTriangles/CXXSurface/CXXCreator.cpp
            ${coot_src}/MoleculesToTriangles/CXXSurface/CXXException.cpp
            ${coot_src}/MoleculesToTriangles/CXXSurface/CXXFFTSolventMap.cpp
            ${coot_src}/MoleculesToTriangles/CXXSurface/CXXFortranFile.cpp
            ${coot_src}/MoleculesToTriangles/CXXSurface/CXXNewHood.cpp
            ${coot_src}/MoleculesToTriangles/CXXSurface/CXXQADSurface.cpp
            ${coot_src}/MoleculesToTriangles/CXXSurface/CXXQADSurfaceStaticData.cpp
            ${coot_src}/MoleculesToTriangles/CXXSurface/CXXSpace.cpp
            ${coot_src}/MoleculesToTriangles/CXXSurface/CXXSphereElement.cpp
            ${coot_src}/MoleculesToTriangles/CXXSurface/CXXSphereNode.cpp
            ${coot_src}/MoleculesToTriangles/CXXSurface/CXXSphereTriangle.cpp
            ${coot_src}/MoleculesToTriangles/CXXSurface/CXXSphereTriangleEdge.cpp
            ${coot_src}/MoleculesToTriangles/CXXSurface/CXXSurface.cpp
            ${coot_src}/MoleculesToTriangles/CXXSurface/CXXSurfaceMaker.cpp
            ${coot_src}/MoleculesToTriangles/CXXSurface/CXXSurfaceVertex.cpp
            ${coot_src}/MoleculesToTriangles/CXXSurface/CXXTorusElement.cpp
            ${coot_src}/MoleculesToTriangles/CXXSurface/CXXTorusNode.cpp
            ${coot_src}/MoleculesToTriangles/CXXSurface/CXXTriangle.cpp
            ${coot_src}/MoleculesToTriangles/CXXSurface/CXXUtils.cpp
            ${coot_src}/MoleculesToTriangles/CXXSurface/CXXVCN.cpp
            #${coot_src}/MoleculesToTriangles/CXXSurface/ElectroSurface.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/AtomPropertyRampColorRule.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/BallsPrimitive.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/BondsPrimitive.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/BoxSectionPrimitive.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/ColorRule.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/ColorScheme.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/CompoundSelection.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/CXXMatrix.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/CylinderPoint.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/CylindersPrimitive.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/DirectedPositionedEntity.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/DiscreteSegment.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/DishyBase.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/DisplayPrimitive.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/ElectrostaticColorScheme.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/FlatFanPrimitive.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/Light.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/LinesPrimitive.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/MolecularRepresentation.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/MolecularRepresentationInstance.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/MyMolecule.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/NRStuff.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/oglPolyhedron.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/Polyhedron.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/PositionedEntity.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/Quaternion.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/Renderer.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/Representation.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/RepresentationInstance.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/RotatedTranslatedScaledEntity.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/SecondaryColorScheme.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/SolidColorRule.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/SpherePrimitive.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/SticksPrimitive.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/SurfacePrimitive.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/Vector2.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/Vector3.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/VertexColorNormalPrimitive.cpp
            ${coot_src}/MoleculesToTriangles/CXXClasses/lfit.c
            ${coot_src}/api/rigid-body-fit.cc
            ${coot_src}/api/blender-mesh.cc
            ${coot_src}/api/add-terminal-residue.cc
            ${coot_src}/api/interfaces.cc
            ${coot_src}/api/instancing.cc
            ${coot_src}/api/colour-functions.cc
            ${coot_src}/api/coot-colour.cc
            ${coot_src}/api/coot-molecule.cc
            ${coot_src}/api/coot-molecule-backup.cc
            ${coot_src}/api/coot-molecule-bonds.cc
            ${coot_src}/api/coot-molecule-bonds-instanced.cc
            ${coot_src}/api/coot-molecule-maps.cc
            ${coot_src}/api/coot-molecule-change-chain-id.cc
            ${coot_src}/api/coot-molecule-moltris.cc
            ${coot_src}/api/coot-molecule-validation.cc
            ${coot_src}/api/coot-molecule-merge-molecules.cc
            ${coot_src}/api/coot-molecule-refine.cc
            ${coot_src}/api/coot-molecule-replace-fragment.cc
            ${coot_src}/api/coot-molecule-blender.cc
            ${coot_src}/api/molecules-container-blender.cc
            ${coot_src}/api/molecules-container.cc
            ${coot_src}/api/molecules-container-bucca-ml-growing.cc
            ${coot_src}/api/molecules-container-maps.cc
            ${coot_src}/api/molecules-container-mmrrcc.cc
            ${coot_src}/api/molecules-container-superpose.cc
            ${coot_src}/api/molecules-container-modelling.cc
            ${coot_src}/api/molecules-container-ligand-fitting.cc
            ${coot_src}/api/phi-psi-prob.cc
            ${coot_src}/api/moorhen-h-bonds.cc
            ${coot_src}/api/add-terminal-residue.cc
            ${coot_src}/api/rama-plot-phi-psi.cc
            ${coot_src}/analysis/daca.cc
            ${coot_src}/analysis/kolmogorov.cc
            ${coot_src}/analysis/stats.cc
            ${coot_src}/analysis/bfkurt.cc
            ${coot_src}/analysis/mogul.cc
            ${coot_src}/analysis/b-factor-histogram.cc
            ${coot_src}/analysis/typed-distances.cc
            ${coot_src}/analysis/cablam.cc
            ${coot_src}/density-contour/density-contour-triangles.cc
            ${coot_src}/density-contour/Vectors.cpp
            ${coot_src}/density-contour/CIsoSurface.cpp
            ${coot_src}/density-contour/occlusion.cc
            ${coot_src}/density-contour/gaussian-surface.cc
            ${coot_src}/ccp4mg-utils/quat.cc
            ${coot_src}/ccp4mg-utils/mgtree.cc
            ${coot_src}/ccp4mg-utils/cartesian.cc
            ${coot_src}/ccp4mg-utils/geomutil.cc
            ${coot_src}/ccp4mg-utils/matrix.cc
            ${coot_src}/skeleton/dm-utils.cc
            ${coot_src}/skeleton/BuildCas.cc
            ${coot_src}/skeleton/graphical_skel.cc
            ${coot_src}/ideal/pepflip.cc
            ${coot_src}/ideal/parallel-planes.cc
            ${coot_src}/ideal/simple-restraint.cc
            ${coot_src}/ideal/ng.cc
            ${coot_src}/ideal/torsion-bonds.cc
            ${coot_src}/ideal/chi-squareds.cc
            ${coot_src}/ideal/trans-peptide.cc
            ${coot_src}/ideal/model-bond-deltas.cc
            ${coot_src}/ideal/make-restraints.cc
            ${coot_src}/ideal/pull-restraint.cc
            ${coot_src}/ideal/neutron.cc
            ${coot_src}/ideal/coot-compare-residues.cc
            ${coot_src}/ideal/link-restraints.cc
            ${coot_src}/ideal/mods.cc
            ${coot_src}/ideal/extra-restraints-kk.cc
            ${coot_src}/ideal/chirals.cc
            ${coot_src}/ideal/extra-restraints.cc
            ${coot_src}/ideal/gradients.cc
            ${coot_src}/ideal/regularize-minimol.cc

=== lhasa/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.25)
project(Lhasa)
set(CMAKE_CXX_STANDARD 17)

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release)
endif()


# -Wno-unused-command-line-argument 

# Causes linker errors for Emscripten > 3.1.48. https://github.com/emscripten-core/emscripten/issues/20949
set(CMAKE_CXX_FLAGS "-Wall --embind-emit-tsd lhasa.d.ts -s USE_PTHREADS=1 -pthread -fwasm-exceptions")
# set(CMAKE_CXX_FLAGS "-Wall -s USE_PTHREADS=1 -pthread -fwasm-exceptions")
set(CMAKE_CXX_FLAGS_RELEASE "-O2")
set(CMAKE_C_FLAGS_RELEASE "-O2")
set(CMAKE_CXX_STANDARD 17)



include_directories(${CMAKE_INSTALL_PREFIX}/include)

# todo: use find_package() for rdkit
include_directories(${CMAKE_INSTALL_PREFIX}/include/rdkit)

set(ENV{EM_PKG_CONFIG_PATH} ${CMAKE_INSTALL_PREFIX}/lib/pkgconfig/)
set(ENV{PKG_CONFIG_PATH} ${CMAKE_INSTALL_PREFIX}/lib/pkgconfig/)
set(ENV{EM_PKG_CONFIG_LIBDIR} ${CMAKE_INSTALL_PREFIX}/lib/)
set(ENV{PKG_CONFIG_LIBDIR} ${CMAKE_INSTALL_PREFIX}/lib/)

if("${EMSCRIPTEN_VERSION}" VERSION_GREATER 3.1.26)
  add_link_options(-sDEFAULT_PTHREAD_STACK_SIZE=2MB -sSTACK_SIZE=5MB)
endif()

add_link_options(-lembind -fwasm-exceptions)

include(FindPkgConfig)
pkg_check_modules(DEPS REQUIRED sigc++-3.0 graphene-1.0)

link_directories(${CMAKE_INSTALL_PREFIX}/lib)
include_directories(${DEPS_INCLUDE_DIRS})

add_library(lh STATIC lhasa.hpp lhasa.cpp)


target_sources(lh PRIVATE
  glog_replacement.hpp
  glog_replacement.cpp
  ../layla/utils.hpp
  ../layla/utils.cpp
  ../layla/ligand_editor_canvas.hpp
  ../layla/ligand_editor_canvas.cpp
  ../layla/ligand_editor_canvas/core.hpp
  ../layla/ligand_editor_canvas/core.cpp
  ../layla/ligand_editor_canvas/model.hpp
  ../layla/ligand_editor_canvas/model.cpp
  ../layla/ligand_editor_canvas/tools.hpp
  ../layla/ligand_editor_canvas/tools.cpp
  ../layla/ligand_editor_canvas/render.hpp
  ../layla/ligand_editor_canvas/render.cpp
)

add_executable(lhasa embind.cpp embind.hpp)

set_target_properties(lhasa PROPERTIES LINK_FLAGS " -s ENVIRONMENT=web,worker -s EXPORT_ES6=1 -s MODULARIZE=1 -s EXPORT_NAME='Lhasa' -s ALLOW_MEMORY_GROWTH=1 -s ASSERTIONS")

target_link_libraries(lhasa PRIVATE 
    RDKitDepictor 
    RDKitcoordgen
    RDKitMolTransforms
    RDKitSmilesParse 
    RDKitMolDraw2D 
    RDKitGraphMol 
    RDKitRDGeneral 
    RDKitRDGeometryLib
    RDKitFileParsers 
    RDKitSubstructMatch 
    RDKitGenericGroups
    RDKitDataStructs
    boost_iostreams 
    boost_serialization
    ${DEPS_LIBRARIES}
    lh
)

=== debian/changelog ===
coot (1.1.08+dfsg-3) unstable; urgency=medium

  * Backport upstream commit to fix application crash (Closes: #1072115)

 -- Andrius Merkys <merkys@debian.org>  Fri, 31 May 2024 08:35:55 -0400

coot (1.1.08+dfsg-2) unstable; urgency=medium

  * Split override_dh_install into arch and indep parts.
  * Cleanup debian/rules.
  * Update debian/copyright.hints.

 -- Andrius Merkys <merkys@debian.org>  Mon, 27 May 2024 07:35:40 -0400

coot (1.1.08+dfsg-1) unstable; urgency=medium

  * New upstream version 1.1.08+dfsg
  * Watch GitHub tags.
  * Drop unused patches, refresh others.
  * Build with libdw.
  * Build with sound support.
  * Install pyrogen Python files, add autopkgtest.
  * Add missing coot dependencies.

 -- Andrius Merkys <merkys@debian.org>  Mon, 27 May 2024 04:40:46 -0400

coot (1.1.07.705.gb7e2c16a2+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #897673)

 -- Andrius Merkys <merkys@debian.org>  Fri, 05 Apr 2024 15:10:59 +0300

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; mode: font-lock -*-

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# Export DH_OPTIONS to save options for binary-common
export DH_OPTIONS

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0 -D_REENTRANT
else
	CFLAGS += -O2 -D_REENTRANT
endif

override_dh_auto_configure:
	dh_auto_configure -- --with-enhanced-ligand-tools --disable-static --with-gemmi=/usr/lib/$(DEB_HOST_MULTIARCH) --with-libdw --with-sound
	dh_auto_configure --buildsystem cmake

execute_after_dh_auto_build:
	dh_auto_build --buildsystem cmake

override_dh_auto_test:

override_dh_auto_install:
	dh_auto_install
	dh_auto_install --buildsystem cmake

	dh_auto_install --sourcedirectory data
	dh_auto_install --sourcedirectory rama-data
	dh_auto_install --sourcedirectory python
	dh_auto_install --sourcedirectory pyrogen

	# Drop the remaining *.la files
	find debian/tmp -name '*.la' | xargs --no-run-if-empty rm

	# Overwrite the LD_LIBRARY_PATH setting
	sed -i 's/LD_LIBRARY_PATH=$$COOT_PREFIX\/lib/LD_LIBRARY_PATH=$$COOT_PREFIX\/lib\/'$(DEB_HOST_MULTIARCH)'\/coot/g' \
	    debian/tmp/usr/bin/*
	sed -i 's/LD_LIBRARY_PATH=$$prfx\/lib/LD_LIBRARY_PATH=\/usr\/lib\/'$(DEB_HOST_MULTIARCH)'\/coot/g' \
	    debian/tmp/usr/bin/pyrogen

	# decode image and convert to smaller sizes
	# TODO: let us reuse pixmaps/coot-icon.png
	uudecode < debian/coot-button-64x64.png.uu
	for g in 22x22 24x24 32x32 48x48; do \
	  convert -geometry $$g coot-button-64x64.png coot-button-$$g.png;\
	done

	# install the newly generated png's in the hicolor theme
	for g in 22x22 24x24 32x32 48x48 64x64; do \
	   install -D coot-button-$$g.png debian/tmp/usr/share/icons/hicolor/$$g/apps/coot.png;\
	done

execute_after_dh_install-arch:
	rm debian/coot/usr/lib/$(DEB_HOST_MULTIARCH)/coot/libcootapi.so*

override_dh_install-indep:
	dh_install -i --exclude=scheme

override_dh_installdocs:
	dh_installdocs RELEASE-NOTES # debian/citation.bib -- not available (?)

override_dh_shlibdeps:
	dh_shlibdeps -l/usr/lib/$(DEB_HOST_MULTIARCH)/coot

execute_after_dh_auto_clean:
	dh_auto_clean --buildsystem cmake

debian/copyright.hints:
	mkdir debian/licensecheck
	rsync -a --exclude .git --exclude debian --exclude '*.jpg' --exclude '*.png' --exclude '*.ogg' . debian/licensecheck/
	sed -i 's/;;;;/ */g' debian/licensecheck/scheme/* # Fixup scheme comments which are not understood by licensecheck
	(cd debian/licensecheck && licensecheck -r . --deb-machine --lines 100) > $@
	rm -rf debian/licensecheck

%:
	dh $@

=== debian/watch ===
version=4
opts="pgpmode=none,repack,repacksuffix=+dfsg,dversionmangle=auto" \
 https://github.com/pemsley/coot/tags \
 (?:.*?/)?Release-@ANY_VERSION@@ARCHIVE_EXT@

## coot 1.1.09+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -53,7 +53,7 @@
 
 set(coot_src ${CMAKE_CURRENT_SOURCE_DIR})
 
-add_definitions(-DANALYSE_REFINEMENT_TIMING -DVERSION="1.x-pre" -DPACKAGE_VERSION="1"
+add_definitions(-DANALYSE_REFINEMENT_TIMING -DPACKAGE_VERSION="1"
   -DHAVE_CXX_THREAD -DHAVE_SSMLIB -DHAVE_BOOST -DUSE_LIBPNG=1 -DCLIPPER_HAS_TOP8000 -DUSE_GEMMI -DHAVE_BOOST_THREAD -DHAVE_GSL
   -DPKGDATADIR="${CMAKE_INSTALL_PREFIX}/share/coot" -DXDATADIR="${CMAKE_INSTALL_PREFIX}/share")
 
@@ -178,6 +178,7 @@
             ${coot_src}/api/coot-molecule-blender.cc
             ${coot_src}/api/molecules-container-blender.cc
             ${coot_src}/api/molecules-container.cc
+            ${coot_src}/api/molecules-container-gltf.cc
             ${coot_src}/api/molecules-container-bucca-ml-growing.cc
             ${coot_src}/api/molecules-container-maps.cc
             ${coot_src}/api/molecules-container-mmrrcc.cc
@@ -227,4 +228,3 @@
             ${coot_src}/ideal/chirals.cc
             ${coot_src}/ideal/extra-restraints.cc
             ${coot_src}/ideal/gradients.cc
-            ${coot_src}/ideal/regularize-minimol.cc

=== lhasa/CMakeLists.txt ===
--- 
+++ 
@@ -9,9 +9,11 @@
 
 # -Wno-unused-command-line-argument 
 
-# Causes linker errors for Emscripten > 3.1.48. https://github.com/emscripten-core/emscripten/issues/20949
-set(CMAKE_CXX_FLAGS "-Wall --embind-emit-tsd lhasa.d.ts -s USE_PTHREADS=1 -pthread -fwasm-exceptions")
-# set(CMAKE_CXX_FLAGS "-Wall -s USE_PTHREADS=1 -pthread -fwasm-exceptions")
+if(MEMORY64 EQUAL "1")
+  set(CMAKE_CXX_FLAGS "-DLHASA_STANDALONE -Wall -sMEMORY64=1 --embind-emit-tsd lhasa.d.ts -s USE_PTHREADS=1 -pthread -fwasm-exceptions")
+else()
+  set(CMAKE_CXX_FLAGS "-DLHASA_STANDALONE -Wall --embind-emit-tsd lhasa.d.ts -s USE_PTHREADS=1 -pthread -fwasm-exceptions")
+endif()
 set(CMAKE_CXX_FLAGS_RELEASE "-O2")
 set(CMAKE_C_FLAGS_RELEASE "-O2")
 set(CMAKE_CXX_STANDARD 17)
@@ -30,6 +32,10 @@
 
 if("${EMSCRIPTEN_VERSION}" VERSION_GREATER 3.1.26)
   add_link_options(-sDEFAULT_PTHREAD_STACK_SIZE=2MB -sSTACK_SIZE=5MB)
+endif()
+
+if(MEMORY64 EQUAL "1")
+  add_link_options(-sMEMORY64=1)
 endif()
 
 add_link_options(-lembind -fwasm-exceptions)

=== debian/changelog ===
coot (1.1.09+dfsg-4) unstable; urgency=medium

  [ Alexandre Detiste ]
  * Add build-dep on python3-setuptools (Closes: #1080574)
  * Fix SyntaxWarning (Closes: #1085529)
  * Apply Multi-Arch: hint

  [ Andrius Merkys ]
  * Fix FTBFS issues with libatomic on riscv64 and mips64el (Closes: 1093752).
    Thanks Bo YU.

 -- Andrius Merkys <merkys@debian.org>  Wed, 22 Jan 2025 03:13:31 -0500

coot (1.1.09+dfsg-3) unstable; urgency=medium

  * Backport upstream's commit fixing Python 3.13 compatibility.
  * Update debian/copyright.

 -- Andrius Merkys <merkys@debian.org>  Tue, 14 Jan 2025 09:15:52 -0500

coot (1.1.09+dfsg-2) unstable; urgency=medium

  [ Alex Myczko ]
  * d/control: updated my name

  [ Andrius Merkys ]
  * Drop dependency on python3-distutils (Closes: #1076203)

 -- Andrius Merkys <merkys@debian.org>  Mon, 22 Jul 2024 03:52:32 -0400

coot (1.1.09+dfsg-1) unstable; urgency=medium

  * New upstream version 1.1.09+dfsg (Closes: #1072576)
  * Disable sound on hurd-i386.
  * Drop a0fbdb6c679b30c576f3ea8ff438f44ee50cc612.patch: integrated upstream.

 -- Andrius Merkys <merkys@debian.org>  Fri, 28 Jun 2024 10:04:00 -0400

=== debian/control ===
Source: coot
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Morten Kjeldgaard <mok0@ubuntu.com>,
 Picca Frédéric-Emmanuel <picca@debian.org>,
 Andrius Merkys <merkys@debian.org>,
 Alex Myczko <tar@debian.org>,
Section: science
Priority: optional
Build-Depends:
 bc,
 cmake,
 debhelper-compat (= 13),
 dh-sequence-python3,
 gemmi,
 gemmi-dev,
 ghostscript,
 imagemagick | graphicsmagick-imagemagick-compat,
 libasound2-dev,
 libblas-dev,
 libboost-dev,
 libboost-iostreams-dev,
 libboost-python-dev,
 libboost-system-dev,
 libboost-thread-dev,
 libcairo-dev,
 libccp4-data,
 libclipper-dev,
 libcurl4-gnutls-dev | libcurl-dev,
 libdw-dev,
 libeigen3-dev,
 libelf-dev,
 libgl-dev,
 libglib2.0-dev,
 libglm-dev,
 libgsl-dev,
 libgtkmm-4.0-dev,
 libmmdb2-dev,
 libpng-dev,
 libpython3-dev,
 librdkit-dev,
 libsqlite3-dev,
 libssm-dev,
 libvorbis-dev,
 nanobind-dev,
 python-gi-dev,
 python3-rdkit,
 python3-requests,
 python3-setuptools,
 sharutils,
 swig,
 tao-pegtl-dev,
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/science-team/coot
Vcs-Git: https://salsa.debian.org/science-team/coot.git
Homepage: https://github.com/pemsley/coot
Rules-Requires-Root: no

Package: coot
Architecture: any
Depends:
 coot-data,
 gir1.2-gtk-4.0,
 python3-gi,
 python3-rdkit,
 refmac-dictionary,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Suggests:
 coot-doc,
Description: model building program for macromolecular crystallography
 This is a program for constructing atomic models of macromolecules
 from x-ray diffraction data. Coot displays electron density maps and
 molecular models and allows model manipulations such as idealization,
 refinement, manual rotation/translation, rigid-body fitting, ligand
 search, solvation, mutations, rotamers. Validation tools such as
 Ramachandran and geometry plots are available to the user. This
 package provides a Coot build with embedded Python support.

Package: coot-data
Architecture: all
Depends:
 fonts-noto-core,
 ttf-bitstream-vera,
 ${misc:Depends},
Description: various data files needed by Coot
 This is an interactive program for fitting atomic models to
 crystallographic electron density maps. This package contains various
 data files needed by Coot.

Package: coot-doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: documentation for Coot
 This is an interactive program for fitting atomic models to
 crystallographic electron density maps. This package contains
 documentation source files for Coot.

Package: libcootapi-dev
Architecture: any
Section: libdevel
Depends:
 libcootapi1.1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: development files for libcoot
 Coot is an interactive program for fitting atomic models to
 crystallographic electron density maps.
 .
 This package contains the development files.

Package: libcootapi1.1
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: shared library for coot
 Coot is an interactive program for fitting atomic models to
 crystallographic electron density maps.
 .
 This package contains the shared library for Coot's API.

=== debian/rules ===
--- 
+++ 
@@ -1,8 +1,4 @@
 #!/usr/bin/make -f
-# -*- mode: makefile; mode: font-lock -*-
-
-# Uncomment this to turn on verbose mode.
-# export DH_VERBOSE=1
 
 # Export DH_OPTIONS to save options for binary-common
 export DH_OPTIONS
@@ -13,8 +9,18 @@
 	CFLAGS += -O2 -D_REENTRANT
 endif
 
+CONFIGURATION_OPTIONS = --with-enhanced-ligand-tools --disable-static --with-gemmi=/usr/lib/$(DEB_HOST_MULTIARCH) --with-libdw
+ifneq ($(DEB_HOST_ARCH),hurd-i386)
+	CONFIGURATION_OPTIONS += --with-sound
+endif
+
+# Link with libatomic on riscv64 and mips64el
+ifneq (,$(filter $(DEB_HOST_ARCH),riscv64 mips64el))
+	export DEB_LDFLAGS_MAINT_APPEND += -Wl,--no-as-needed -latomic -Wl,--as-needed
+endif
+
 override_dh_auto_configure:
-	dh_auto_configure -- --with-enhanced-ligand-tools --disable-static --with-gemmi=/usr/lib/$(DEB_HOST_MULTIARCH) --with-libdw --with-sound
+	dh_auto_configure -- $(CONFIGURATION_OPTIONS)
 	dh_auto_configure --buildsystem cmake
 
 execute_after_dh_auto_build:
@@ -34,7 +40,9 @@
 	# Drop the remaining *.la files
 	find debian/tmp -name '*.la' | xargs --no-run-if-empty rm
 
-	# Overwrite the LD_LIBRARY_PATH setting
+	# Adjust the LD_LIBRARY_PATH setting
+	sed -i 's/$${exec_prefix}\/libexec\/Coot/LD_LIBRARY_PATH=$${prefix}\/lib\/'$(DEB_HOST_MULTIARCH)'\/coot $${exec_prefix}\/libexec\/Coot/' \
+	    debian/tmp/usr/bin/coot
 	sed -i 's/LD_LIBRARY_PATH=$$COOT_PREFIX\/lib/LD_LIBRARY_PATH=$$COOT_PREFIX\/lib\/'$(DEB_HOST_MULTIARCH)'\/coot/g' \
 	    debian/tmp/usr/bin/*
 	sed -i 's/LD_LIBRARY_PATH=$$prfx\/lib/LD_LIBRARY_PATH=\/usr\/lib\/'$(DEB_HOST_MULTIARCH)'\/coot/g' \

## coot 1.1.14+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -27,11 +27,12 @@
 find_package(Boost COMPONENTS iostreams system python regex thread serialization REQUIRED)
 find_package(glm REQUIRED)
 
+set(THREADS_PREFER_PTHREAD_FLAG ON)
 
 # Charles wants 3.9 here, but if I change to 3.9 then it will not build for me
 # Hmm...
 # What do I need to do here so that Charles can specify on the command line what the version of Python should be?
-find_package(Python 3.10
+find_package(Python 3.12.4
   REQUIRED COMPONENTS Interpreter Development.Module
   OPTIONAL_COMPONENTS Development.SABIModule)
 
@@ -53,19 +54,17 @@
 
 set(coot_src ${CMAKE_CURRENT_SOURCE_DIR})
 
-add_definitions(-DANALYSE_REFINEMENT_TIMING -DPACKAGE_VERSION="1"
+add_definitions(-DANALYSE_REFINEMENT_TIMING -DPACKAGE_VERSION="1.1.14"
   -DHAVE_CXX_THREAD -DHAVE_SSMLIB -DHAVE_BOOST -DUSE_LIBPNG=1 -DCLIPPER_HAS_TOP8000 -DUSE_GEMMI -DHAVE_BOOST_THREAD -DHAVE_GSL
   -DPKGDATADIR="${CMAKE_INSTALL_PREFIX}/share/coot" -DXDATADIR="${CMAKE_INSTALL_PREFIX}/share")
 
-if (ENHANCED_LIGAND_TOOLS)
-   add_definitions(-DMAKE_ENHANCED_LIGAND_TOOLS)
-   message("-- Found ENHANCED_LIGAND_TOOLS setting - now requiring the RDKit")
-   find_package(Cairo REQUIRED)
-   find_package(RDKit CONFIG COMPONENTS RDGeneral REQUIRED)
-   set(RDKit_libs_for_libcootapi RDKit::rdkit_base RDKit::Descriptors RDKit::ForceFieldHelpers RDKit::ForceField RDKit::Optimizer RDKit::MolDraw2D  RDKit::MolChemicalFeatures)
-else()
-    message("-- Note: MAKE_ENHANCED_LIGAND_TOOLS was not enabled")
-endif()
+# 20250314-PE: Charles, I guess that you will need to comment out this block
+#
+add_definitions(-DMAKE_ENHANCED_LIGAND_TOOLS="1")
+message("-- Found ENHANCED_LIGAND_TOOLS setting - now requiring the RDKit")
+find_package(Cairo REQUIRED)
+find_package(RDKit CONFIG COMPONENTS RDGeneral REQUIRED)
+set(RDKit_libs_for_libcootapi RDKit::rdkit_base RDKit::Descriptors RDKit::ForceFieldHelpers RDKit::ForceField RDKit::Optimizer RDKit::MolDraw2D  RDKit::MolChemicalFeatures)
 
 # we can be on Apple, and also have access to homebrew dwarf and elf - but this typically not the case
 # should this actually be ENABLE_BACKWARD? (util/backward.cpp is not conditionally compiled)
@@ -89,7 +88,6 @@
             ${coot_src}/lidia-core/cod-atom-type-t.cc
             ${coot_src}/lidia-core/rdkit-interface.cc
             ${coot_src}/lidia-core/bond-table-record-t.cc
-            ${coot_src}/pli/pi-stacking.cc
             ${coot_src}/src/coot-hydrogens.cc
             ${coot_src}/src/cfc.cc
             ${coot_src}/MoleculesToTriangles/CXXSurface/CXXBall.cpp
@@ -157,6 +155,7 @@
             ${coot_src}/MoleculesToTriangles/CXXClasses/Vector3.cpp
             ${coot_src}/MoleculesToTriangles/CXXClasses/VertexColorNormalPrimitive.cpp
             ${coot_src}/MoleculesToTriangles/CXXClasses/lfit.c
+            ${coot_src}/MoleculesToTriangles/CXXClasses/tubes.cc
             ${coot_src}/api/rigid-body-fit.cc
             ${coot_src}/api/blender-mesh.cc
             ${coot_src}/api/add-terminal-residue.cc
@@ -166,6 +165,7 @@
             ${coot_src}/api/coot-colour.cc
             ${coot_src}/api/coot-molecule.cc
             ${coot_src}/api/coot-molecule-backup.cc
+            ${coot_src}/api/coot-molecule-blender.cc
             ${coot_src}/api/coot-molecule-bonds.cc
             ${coot_src}/api/coot-molecule-bonds-instanced.cc
             ${coot_src}/api/coot-molecule-maps.cc
@@ -173,21 +173,22 @@
             ${coot_src}/api/coot-molecule-moltris.cc
             ${coot_src}/api/coot-molecule-validation.cc
             ${coot_src}/api/coot-molecule-merge-molecules.cc
+            ${coot_src}/api/coot-molecule-modelling.cc
             ${coot_src}/api/coot-molecule-refine.cc
             ${coot_src}/api/coot-molecule-replace-fragment.cc
-            ${coot_src}/api/coot-molecule-blender.cc
+            ${coot_src}/api/ghost-molecule-display.cc
+            ${coot_src}/api/molecules-container.cc
             ${coot_src}/api/molecules-container-blender.cc
-            ${coot_src}/api/molecules-container.cc
+            ${coot_src}/api/molecules-container-bucca-ml-growing.cc
             ${coot_src}/api/molecules-container-gltf.cc
-            ${coot_src}/api/molecules-container-bucca-ml-growing.cc
             ${coot_src}/api/molecules-container-maps.cc
             ${coot_src}/api/molecules-container-mmrrcc.cc
             ${coot_src}/api/molecules-container-superpose.cc
             ${coot_src}/api/molecules-container-modelling.cc
             ${coot_src}/api/molecules-container-ligand-fitting.cc
+            ${coot_src}/api/mmcif-tests.cc
             ${coot_src}/api/phi-psi-prob.cc
             ${coot_src}/api/moorhen-h-bonds.cc
-            ${coot_src}/api/add-terminal-residue.cc
             ${coot_src}/api/rama-plot-phi-psi.cc
             ${coot_src}/analysis/daca.cc
             ${coot_src}/analysis/kolmogorov.cc
@@ -197,6 +198,7 @@
             ${coot_src}/analysis/b-factor-histogram.cc
             ${coot_src}/analysis/typed-distances.cc
             ${coot_src}/analysis/cablam.cc
+            ${coot_src}/analysis/chi-squared.cc
             ${coot_src}/density-contour/density-contour-triangles.cc
             ${coot_src}/density-contour/Vectors.cpp
             ${coot_src}/density-contour/CIsoSurface.cpp
@@ -224,7 +226,3 @@
             ${coot_src}/ideal/coot-compare-residues.cc
             ${coot_src}/ideal/link-restraints.cc
             ${coot_src}/ideal/mods.cc
-            ${coot_src}/ideal/extra-restraints-kk.cc
-            ${coot_src}/ideal/chirals.cc
-            ${coot_src}/ideal/extra-restraints.cc
-            ${coot_src}/ideal/gradients.cc

=== debian/changelog ===
coot (1.1.14+dfsg-1) unstable; urgency=medium

  * New upstream version 1.1.14+dfsg

 -- Andrius Merkys <merkys@debian.org>  Wed, 19 Mar 2025 08:17:57 -0400

coot (1.1.11+dfsg-2) unstable; urgency=medium

  * Fix the location to coot's shared libraries in /usr/bin/coot.
  * Set LD_LIBRARY_PATH for layla via wrapper (Closes: #1072618)

 -- Andrius Merkys <merkys@debian.org>  Tue, 18 Mar 2025 08:38:11 -0400

coot (1.1.11+dfsg-1) unstable; urgency=medium

  * New upstream version 1.1.11+dfsg
  * Link with -latomic on loong64 (Closes: #1099488). Thanks Dandan Zhang.
  * Refresh patches.
  * Drop 26c08247673834ba561feeb9260c4f1f339ef4b5.patch (integrated upstream)
  * Explicitly indicate buildsystem for dh_auto_configure.

 -- Andrius Merkys <merkys@debian.org>  Mon, 17 Mar 2025 11:00:29 +0200

## coot 1.1.15+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -54,7 +54,7 @@
 
 set(coot_src ${CMAKE_CURRENT_SOURCE_DIR})
 
-add_definitions(-DANALYSE_REFINEMENT_TIMING -DPACKAGE_VERSION="1.1.14"
+add_definitions(-DANALYSE_REFINEMENT_TIMING -DPACKAGE_VERSION="1.1.15"
   -DHAVE_CXX_THREAD -DHAVE_SSMLIB -DHAVE_BOOST -DUSE_LIBPNG=1 -DCLIPPER_HAS_TOP8000 -DUSE_GEMMI -DHAVE_BOOST_THREAD -DHAVE_GSL
   -DPKGDATADIR="${CMAKE_INSTALL_PREFIX}/share/coot" -DXDATADIR="${CMAKE_INSTALL_PREFIX}/share")

=== debian/changelog ===
coot (1.1.15+dfsg-1build1) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 08 Aug 2025 05:34:30 +0200

coot (1.1.15+dfsg-1) unstable; urgency=medium

  * New upstream version 1.1.15+dfsg

 -- Andrius Merkys <merkys@debian.org>  Wed, 02 Apr 2025 09:40:07 -0400

## coot 1.1.18+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -10,7 +10,9 @@
   set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
 endif()
 
-set(CMAKE_CXX_STANDARD 17)
+# C++20 is only used because newest versions of RDKit (March 2025 and newer) seems to require it
+# Without RDKit, Coot currently needs C++17
+set(CMAKE_CXX_STANDARD 20)
 
 if (APPLE)
 else()
@@ -24,18 +26,18 @@
 find_package(Threads REQUIRED)
 find_package(Python REQUIRED)
 
-find_package(Boost COMPONENTS iostreams system python regex thread serialization REQUIRED)
+find_package(Boost COMPONENTS iostreams system regex thread serialization REQUIRED)
 find_package(glm REQUIRED)
 
 set(THREADS_PREFER_PTHREAD_FLAG ON)
 
-# Charles wants 3.9 here, but if I change to 3.9 then it will not build for me
-# Hmm...
-# What do I need to do here so that Charles can specify on the command line what the version of Python should be?
-find_package(Python 3.12.4
+find_package(Python 3
   REQUIRED COMPONENTS Interpreter Development.Module
   OPTIONAL_COMPONENTS Development.SABIModule)
 
+# This is flaky.
+# If it doesn't work, first try setting nanobind_DIR to wherever_your_python_is/lib/python3.$your_python_version/site-packages/nanobind/cmake
+# If that doesn't work, make sure that CMAKE_INSTALL_PREFIX is set
 find_package(nanobind CONFIG REQUIRED)
 
 # only via homebrew on macOS (not tried to compile them myself) - see below also though.
@@ -54,7 +56,7 @@
 
 set(coot_src ${CMAKE_CURRENT_SOURCE_DIR})
 
-add_definitions(-DANALYSE_REFINEMENT_TIMING -DPACKAGE_VERSION="1.1.15"
+add_definitions(-DANALYSE_REFINEMENT_TIMING -DPACKAGE_VERSION="1.1.18"
   -DHAVE_CXX_THREAD -DHAVE_SSMLIB -DHAVE_BOOST -DUSE_LIBPNG=1 -DCLIPPER_HAS_TOP8000 -DUSE_GEMMI -DHAVE_BOOST_THREAD -DHAVE_GSL
   -DPKGDATADIR="${CMAKE_INSTALL_PREFIX}/share/coot" -DXDATADIR="${CMAKE_INSTALL_PREFIX}/share")
 
@@ -67,7 +69,8 @@
 set(RDKit_libs_for_libcootapi RDKit::rdkit_base RDKit::Descriptors RDKit::ForceFieldHelpers RDKit::ForceField RDKit::Optimizer RDKit::MolDraw2D  RDKit::MolChemicalFeatures)
 
 # we can be on Apple, and also have access to homebrew dwarf and elf - but this typically not the case
-# should this actually be ENABLE_BACKWARD? (util/backward.cpp is not conditionally compiled)
+# should this actually be ENABLE_BACKWARD? (util/backward.cpp is not conditionally compiled).
+# This doesn't seem to wort at the moment though - maybe a  problem with libdwarf.
 if (ENABLE_DWARF_ELF)
    find_library(libelf elf)
    find_library(libdwarf dw)
@@ -88,8 +91,6 @@
             ${coot_src}/lidia-core/cod-atom-type-t.cc
             ${coot_src}/lidia-core/rdkit-interface.cc
             ${coot_src}/lidia-core/bond-table-record-t.cc
-            ${coot_src}/src/coot-hydrogens.cc
-            ${coot_src}/src/cfc.cc
             ${coot_src}/MoleculesToTriangles/CXXSurface/CXXBall.cpp
             ${coot_src}/MoleculesToTriangles/CXXSurface/CXXChargeTable.cpp
             ${coot_src}/MoleculesToTriangles/CXXSurface/CXXCircle.cpp
@@ -177,6 +178,7 @@
             ${coot_src}/api/coot-molecule-refine.cc
             ${coot_src}/api/coot-molecule-replace-fragment.cc
             ${coot_src}/api/ghost-molecule-display.cc
+            ${coot_src}/api/model-analysis.cc
             ${coot_src}/api/molecules-container.cc
             ${coot_src}/api/molecules-container-blender.cc
             ${coot_src}/api/molecules-container-bucca-ml-growing.cc
@@ -212,6 +214,7 @@
             ${coot_src}/skeleton/dm-utils.cc
             ${coot_src}/skeleton/BuildCas.cc
             ${coot_src}/skeleton/graphical_skel.cc
+            ${coot_src}/ideal/add-linked-cho.cc
             ${coot_src}/ideal/pepflip.cc
             ${coot_src}/ideal/parallel-planes.cc
             ${coot_src}/ideal/simple-restraint.cc
@@ -221,8 +224,3 @@
             ${coot_src}/ideal/trans-peptide.cc
             ${coot_src}/ideal/model-bond-deltas.cc
             ${coot_src}/ideal/make-restraints.cc
-            ${coot_src}/ideal/pull-restraint.cc
-            ${coot_src}/ideal/neutron.cc
-            ${coot_src}/ideal/coot-compare-residues.cc
-            ${coot_src}/ideal/link-restraints.cc
-            ${coot_src}/ideal/mods.cc

=== canyon/Makefile ===


COOT_INSTALL=$(HOME)/autobuild/build-coot+rdkit-pre-release-gtk2-python

CXXFLAGS=-I$(COOT_INSTALL)/include -I$(COOT_INSTALL)/include/coot -g

LDFLAGS=-L$(COOT_INSTALL)/lib -g -lcoot-coord-utils -lclipper-core -lmmdb2

canyon: canyon.o quaternion.o
	libtool --mode=link $(CXX) -o $@ $^ $(LDFLAGS)

quaternion.o: quaternion.cc quaternion.hh
	libtool --mode=compile $(CXX) $(CXXFLAGS) -c $<

canyon.o: canyon.cc canyon.hh
	libtool --mode=compile $(CXX) $(CXXFLAGS) -c $<

clean:
	rm -f canyon canyon.o canyon.lo

dist:
	d=$$(date +%Y-%m-%d-%H%M) && echo $$d && tar czf canyon-$$d.tar.gz canyon.cc canyon.hh quaternion.cc quaternion.hh Makefile

=== lhasa/CMakeLists.txt ===
--- 
+++ 
@@ -10,9 +10,9 @@
 # -Wno-unused-command-line-argument 
 
 if(MEMORY64 EQUAL "1")
-  set(CMAKE_CXX_FLAGS "-DLHASA_STANDALONE -Wall -sMEMORY64=1 --embind-emit-tsd lhasa.d.ts -s USE_PTHREADS=1 -pthread -fwasm-exceptions")
+  set(CMAKE_CXX_FLAGS "-Wall -sMEMORY64=1 --emit-tsd lhasa.d.ts -s USE_PTHREADS=1 -pthread -fwasm-exceptions")
 else()
-  set(CMAKE_CXX_FLAGS "-DLHASA_STANDALONE -Wall --embind-emit-tsd lhasa.d.ts -s USE_PTHREADS=1 -pthread -fwasm-exceptions")
+  set(CMAKE_CXX_FLAGS "-Wall --emit-tsd lhasa.d.ts -s USE_PTHREADS=1 -pthread -fwasm-exceptions")
 endif()
 set(CMAKE_CXX_FLAGS_RELEASE "-O2")
 set(CMAKE_C_FLAGS_RELEASE "-O2")
@@ -52,6 +52,8 @@
 target_sources(lh PRIVATE
   glog_replacement.hpp
   glog_replacement.cpp
+  ../layla/qed.hpp
+  ../layla/qed.cpp
   ../layla/utils.hpp
   ../layla/utils.cpp
   ../layla/ligand_editor_canvas.hpp
@@ -64,11 +66,14 @@
   ../layla/ligand_editor_canvas/tools.cpp
   ../layla/ligand_editor_canvas/render.hpp
   ../layla/ligand_editor_canvas/render.cpp
+  ../utils/base64-encode-decode.hh
+  ../utils/base64-encode-decode.cc
 )
 
 add_executable(lhasa embind.cpp embind.hpp)
 
-set_target_properties(lhasa PROPERTIES LINK_FLAGS " -s ENVIRONMENT=web,worker -s EXPORT_ES6=1 -s MODULARIZE=1 -s EXPORT_NAME='Lhasa' -s ALLOW_MEMORY_GROWTH=1 -s ASSERTIONS")
+set_target_properties(lhasa PROPERTIES LINK_FLAGS " -s ENVIRONMENT=web,worker -s MODULARIZE=1 -s EXPORT_NAME='Lhasa' -s ALLOW_MEMORY_GROWTH=1 -s ASSERTIONS")
+#set_target_properties(lhasa PROPERTIES LINK_FLAGS " -s ENVIRONMENT=web,worker -s EXPORT_ES6=1 -s MODULARIZE=1 -s EXPORT_NAME='Lhasa' -s ALLOW_MEMORY_GROWTH=1 -s ASSERTIONS")
 
 target_link_libraries(lhasa PRIVATE 
     RDKitDepictor 
@@ -80,7 +85,9 @@
     RDKitRDGeneral 
     RDKitRDGeometryLib
     RDKitFileParsers 
-    RDKitSubstructMatch 
+    RDKitDescriptors
+    RDKitChemTransforms
+    RDKitSubstructMatch
     RDKitGenericGroups
     RDKitDataStructs
     boost_iostreams

=== debian/changelog ===
coot (1.1.18+dfsg-2) unstable; urgency=medium

  * Upload to unstable (Closes: #1117743)
  * Update debian/copyright.
  * Refresh patches, bring back system-fonts.patch, remove alternative
    patches fonts-gone and without-fonts.

 -- Andrius Merkys <merkys@debian.org>  Mon, 27 Oct 2025 06:06:01 -0400

coot (1.1.18+dfsg-1) experimental; urgency=medium

  * New upstream version.

 -- Alex Myczko <tar@debian.org>  Tue, 16 Sep 2025 11:15:47 +0200

=== debian/control ===
--- 
+++ 
@@ -26,6 +26,7 @@
  libcairo-dev,
  libccp4-data,
  libclipper-dev,
+ libcoordgen-dev,
  libcurl4-gnutls-dev | libcurl-dev,
  libdw-dev,
  libeigen3-dev,
@@ -35,6 +36,7 @@
  libglm-dev,
  libgsl-dev,
  libgtkmm-4.0-dev,
+ libmaeparser-dev,
  libmmdb2-dev,
  libpng-dev,
  libpython3-dev,

=== debian/rules ===
--- 
+++ 
@@ -14,13 +14,13 @@
 	CONFIGURATION_OPTIONS += --with-sound
 endif
 
-# Link with libatomic on riscv64 and mips64el
-ifneq (,$(filter $(DEB_HOST_ARCH),riscv64 mips64el))
+# Link with libatomic on riscv64, mips64el and loong64
+ifneq (,$(filter $(DEB_HOST_ARCH),riscv64 mips64el loong64))
 	export DEB_LDFLAGS_MAINT_APPEND += -Wl,--no-as-needed -latomic -Wl,--as-needed
 endif
 
 override_dh_auto_configure:
-	dh_auto_configure -- $(CONFIGURATION_OPTIONS)
+	dh_auto_configure --buildsystem autoconf -- $(CONFIGURATION_OPTIONS)
 	dh_auto_configure --buildsystem cmake
 
 execute_after_dh_auto_build:
@@ -41,12 +41,19 @@
 	find debian/tmp -name '*.la' | xargs --no-run-if-empty rm
 
 	# Adjust the LD_LIBRARY_PATH setting
-	sed -i 's/$${exec_prefix}\/libexec\/Coot/LD_LIBRARY_PATH=$${prefix}\/lib\/'$(DEB_HOST_MULTIARCH)'\/coot $${exec_prefix}\/libexec\/Coot/' \
+	sed -i 's/$${exec_prefix}\/libexec\/coot-1/LD_LIBRARY_PATH=$${prefix}\/lib\/'$(DEB_HOST_MULTIARCH)'\/coot $${exec_prefix}\/libexec\/coot-1/' \
 	    debian/tmp/usr/bin/coot
 	sed -i 's/LD_LIBRARY_PATH=$$COOT_PREFIX\/lib/LD_LIBRARY_PATH=$$COOT_PREFIX\/lib\/'$(DEB_HOST_MULTIARCH)'\/coot/g' \
 	    debian/tmp/usr/bin/*
 	sed -i 's/LD_LIBRARY_PATH=$$prfx\/lib/LD_LIBRARY_PATH=\/usr\/lib\/'$(DEB_HOST_MULTIARCH)'\/coot/g' \
 	    debian/tmp/usr/bin/pyrogen
+
+	# Wrapper for layla (#1072618)
+	mkdir --parents debian/tmp/usr/libexec
+	mv debian/tmp/usr/bin/layla debian/tmp/usr/libexec
+	echo '#!/bin/sh' > debian/tmp/usr/bin/layla
+	echo LD_LIBRARY_PATH=/usr/lib/$(DEB_HOST_MULTIARCH)/coot /usr/libexec/layla >> debian/tmp/usr/bin/layla
+	chmod +x debian/tmp/usr/bin/layla
 
 	# decode image and convert to smaller sizes
 	# TODO: let us reuse pixmaps/coot-icon.png

=== debian/tests/control ===
Test-Command: coot --self-test
Depends:
 @,

Test-Command: pyrogen --help
Depends:
 @,

=== debian/watch ===
version=4
opts="pgpmode=none,repack,repacksuffix=+dfsg,dversionmangle=auto,uversionmangle=s/-build-fixup$//" \
 https://github.com/pemsley/coot/tags \
 (?:.*?/)?Release-@ANY_VERSION@@ARCHIVE_EXT@
